package com.nisum.webflux_poc.controller;

import reactor.core.publisher.Flux;

public class BackpressureExample {
    public static void main(String[] args) {
        Flux<Integer> flux = Flux.range(1, 1000)  // A stream of 1000 integers
                .log();  // Logs the processing of each item

        // Requesting data from the stream in chunks of 100
        flux
                .onBackpressureBuffer(100, // Buffer size
                        (i) -> System.out.println("Dropped item: " + i)) // Action on dropped items
                .subscribe(System.out::println,  // Consumer processes the data
                        Throwable::printStackTrace,
                        () -> System.out.println("Completed"));
    }
}
