package com.nisum.webflux_poc.utills;

import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.nisum.webflux_poc.model.Employee;
import com.nisum.webflux_poc.dto.EmployeeDto;
import org.springframework.beans.BeanUtils;
import org.springframework.core.io.ClassPathResource;

import java.io.File;
import java.io.IOException;
import java.util.List;

public class AppUtils {

    public static EmployeeDto entityToDto(Employee employee) {
        EmployeeDto employeeDto = new EmployeeDto();
        BeanUtils.copyProperties(employee, employeeDto);
        return employeeDto;
    }

    public static Employee dtoToentity(EmployeeDto employeeDto){
        Employee employee=new Employee();
        BeanUtils.copyProperties(employeeDto, employee);
        return employee;
    }

    public static List<EmployeeDto> readFile(String filePath) throws IOException {
        File file = new ClassPathResource(filePath).getFile();
        ObjectMapper objectMapper = new ObjectMapper();
        List<EmployeeDto> employeeList = objectMapper.readValue(file, new TypeReference<List<EmployeeDto>>() {});
        return employeeList;

    }

    public static EmployeeDto readEmployeeFile(String filePath) throws IOException {
        File file = new ClassPathResource(filePath).getFile();
        ObjectMapper objectMapper = new ObjectMapper();
        EmployeeDto employee = objectMapper.readValue(file, EmployeeDto.class);
        return employee;

    }

}
